/*
**	dividString.c
*/
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include "opencasl.h"

char *skipSpace(char *s)
{
	while (*s) {
		if (!isspace(*s)) {
			break;
		}
		s++;
	}
	return s;
}

static	char	tmpbuf[BUFSIZ];

int dividString(char *items[], char *s)
{
	int		i = 0;
	char	*d;

	for (d = tmpbuf; *s != NUL && *s != ';' && *s != '\n'; s++) {
		s = skipSpace(s);
		switch(*s) {
		case '\'':
			items[i++] = d;
			*d++ = *s++;
			while (*s) {
				if (*s == '\'') {
					*d++ = *s;
					*d++ = NUL;
					break;
				}
				*d++ = *s++;
			}
			break;
		case ',':
			*d = *s;
			items[i++] = d++;
			*d++ = NUL;
			break;
		case NUL:
		case ';':
		case '\n':
			goto divid_string_term;
		default:
			items[i++] = d;
			while (!isspace(*s) && *s) {
				if (*s == ',') {
					*d++ = NUL;
					items[i++] = d;
					*d++ = *s;
					break;
				} else {
					*d++ = toupper(*s);
					s++;
				}
			}
			*d++ = NUL;
			break;
		}
	}
divid_string_term:
	items[i] = NULL;
	return	i;
}
